@echo off

::
:: Copyright (c) 2011-2012 EBM WebSourcing, 2012-2018 Linagora
::
:: This program/library is free software: you can redistribute it and/or modify
:: it under the terms of the GNU Lesser General Public License as published by
:: the Free Software Foundation, either version 2.1 of the License, or (at your
:: option) any later version.
::
:: This program/library is distributed in the hope that it will be useful, but
:: WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
:: FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
:: for more details.
::
:: You should have received a copy of the GNU Lesser General Public License
:: along with this program/library; If not, see http://www.gnu.org/licenses/
:: for the GNU Lesser General Public License version 2.1.
::
:: --------------------------------------------------------------------------------
::
::                   Petals ESB - Bootstrap script
::
:: Environment variables:
::
::     JAVA_HOME   			Home directory of the JVM to be used
::
::     JAVA_OPTS 			Options for the JVM. Try "java -h" to get informations
::                 			about the available options for your environment
::
::     PETALS_CLASSPATH     Extra classpath entries for the system classloader.
::                          Careful because they will be visible by the whole JVM.
::
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

:: The Java executable
if not defined JAVA_HOME (
   set JAVA=java
) else (
   set JAVA="%JAVA_HOME%\bin\java.exe"
)

:: The Petals home
if not defined PETALS_HOME (
   set PETALS_HOME="%CD%\.."
)

if not exist %PETALS_HOME% (
   echo PETALS_HOME is not valid: %PETALS_HOME%
   goto :EOF
)

:: Keep the Petals home without any quote
set RAW_PETALS_HOME=%PETALS_HOME:"=%
set RAW_PETALS_LIB_DIR=%RAW_PETALS_HOME%\lib
set RAW_PETALS_EXT_DIR=%RAW_PETALS_HOME%\extensions
set RAW_PETALS_SYSEXT_DIR=%RAW_PETALS_HOME%\system-extensions
set RAW_PETALS_CONF_DIR=%RAW_PETALS_HOME%\conf
set RAW_PETALS_LOG_DIR=%RAW_PETALS_HOME%\logs

:: Retrieve the path to petals launcher jar
set PETALS_LAUNCHER_PATTERN=petals-launcher-default-*.jar
for %%a in ("%RAW_PETALS_LIB_DIR%\%PETALS_LAUNCHER_PATTERN%") do (
   if not defined PETALS_LAUNCHER_ARTIFACT (
      set PETALS_LAUNCHER_ARTIFACT=%%a
   )
)
if not defined PETALS_LAUNCHER_ARTIFACT (
   echo ERROR: No Petals launcher found in directory '%$RAW_PETALS_LIB_DIR'. Pattern searched in the directory: %PETALS_LAUNCHER_PATTERN%
   goto :EOF
)

:: Retrieve the path to petals bootstrap jar
set PETALS_BOOTSTRAP_PATTERN=petals-bootstrap-launcher-*.jar
for %%a in ("%RAW_PETALS_LIB_DIR%\%PETALS_BOOTSTRAP_PATTERN%") do (
   if not defined PETALS_BOOTSTRAP_ARTIFACT (
      set PETALS_BOOTSTRAP_ARTIFACT=%%a
   )
)
if not defined PETALS_BOOTSTRAP_ARTIFACT (
   echo ERROR: No Petals Bootstrap launcher found in directory '%$RAW_PETALS_LIB_DIR'. Pattern searched in the directory: %PETALS_BOOTSTRAP_PATTERN%
   goto :EOF
)

:: Add the conf directory to the classpath to provide the default server configuration
set PETALS_CLASSPATH=%PETALS_BOOTSTRAP_ARTIFACT%;%RAW_PETALS_CONF_DIR%;%RAW_PETALS_SYSEXT_DIR%;%PETALS_CLASSPATH%

set ENV_FILE="%RAW_PETALS_CONF_DIR%/env.bat"
if exist %ENV_FILE% (
	call %ENV_FILE%
)

:: Start
start "OW2 :: Petals Enterprise Service Bus" %JAVA% -classpath %PETALS_CLASSPATH% -Dpetals.lib.dir="%RAW_PETALS_LIB_DIR%" -Dpetals.ext.dir="%RAW_PETALS_EXT_DIR%" -Dpetals.log.dir="%RAW_PETALS_LOG_DIR%" %JAVA_OPTS% org.ow2.petals.BootstrapLauncher %PETALS_LAUNCHER_ARTIFACT%
